Ruby - Bug #6784

Test failures related to numeric with x64 mingw
07/24/2012 07:24 AM - h.shirosaki (Hiroshi Shirosaki)

Status: Closed

Priority: Normal

Assignee: h.shirosaki (Hiroshi Shirosaki)

Target version: 2.0.0

ruby -v: ruby 2.0.0dev (2012-07-23 trunk 36499) |Backport:
[x64-mingw32]

Description
x64 mingw build has many floating point numeric related failures in test-all.

http://ci.rubyinstaller.org/job/test-ruby-trunk-x64/24/console

1. Failure:
test_plus(TestBignum) [C:/Users/Worker/Jenkins/workspace/git-ruby-trunk/test/ruby/test_bignum.rb:244]:
<2535301200456458802993406410752> expected but was
<2.535301200456461e+30>.

2. Failure:
test_sub(TestBignum) [C:/Users/Worker/Jenkins/workspace/qgit-ruby-trunk/test/ruby/test_bignum.rb:232]:
<0> expected but was
<-2.251799813685248e+15>.

3. Failure:
test_divide(TestFixnum) [C:/Users/Worker/Jenkins/workspace/git-ruby-trunk/test/ruby/test_fixnum.rb:156]:
<2.328306436538698e-10> expected but was
<(1/4294967296)>.

4. Failure:
test_pow?2(TestFixnum) [C:/Users/Worker/Jenkins/workspace/git-ruby-trunk/test/ruby/test_fixnum.rb:184]:
<1.5258789062500007e-05> expected but was
<(1/65536)>.

5. Failure:
test_divmod2(TestFloat) [C:/Users/Worker/Jenkins/workspace/git-ruby-trunk/test/ruby/test_float.rb:269]:
<4294967296> expected but was
<4294967295>.

6. Failure:

test_round_with_precision(TestFloat) [C:/Users/Worker/Jenkins/workspace/git-ruby-trunk/test/ruby/test_float.rb:382]:

<1.1> expected but was
<1.0999999999999999>.

This seems cause of broken pow() implementation of x64 mingw.
Using powl() instead of pow() will fix this. | attached the patch.

| tested it with gcc version 4.6.1 (tdm64-1) on Win7.

Associated revisions

Revision 418b1384df0009675263efeb56cb489b79addb14 - 07/24/2012 03:12 PM - h.shirosaki (Hiroshi Shirosaki)

Fix broken pow() on x64-mingw32
¢ include/ruby/win32.h (rb_w32_pow): add new function.
We use powl() instead of broken pow() for x64-mingw32. This workaround
fixes test failures related to floating point numeric.
[ruby-core:46686] [Bug #6784]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@36522 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 4f8b1384 - 07/24/2012 03:12 PM - h.shirosaki (Hiroshi Shirosaki)
Fix broken pow() on x64-mingw32
¢ include/ruby/win32.h (rb_w32_pow): add new function.
We use powl() instead of broken pow() for x64-mingw32. This workaround

fixes test failures related to floating point numeric.
[ruby-core:46686] [Bug #6784]

git-svn-id: svn+ssh:/ci.ruby-lang.org/ruby/trunk@36522 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 0414c9b901a3764b7cdb549d3273e7e54210c8ff - 09/24/2012 07:34 AM - naruse (Yui NARUSE)
merge revision(s) 36522: [Backport #7016]
* include/ruby/win32.h (rb_w32_pow): add new function.
We use powl () instead of broken pow() for x64-mingw32. This workaround

fixes test failures related to floating point numeric.
[ruby-core:46686] [Bug #6784]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_9 3@37024 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 0414c9b9 - 09/24/2012 07:34 AM - naruse (Yui NARUSE)
merge revision(s) 36522: [Backport #7016]
* include/ruby/win32.h (rb_w32_pow): add new function.
We use powl () instead of broken pow() for x64-mingw32. This workaround
fixes test failures related to floating point numeric.

[ruby-core:46686] [Bug #6784]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_9 3@37024 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 07/24/2012 08:13 AM - luislavena (Luis Lavena)

- Category set to core

- Status changed from Open to Assigned

- Assignee changed from luislavena (Luis Lavena) to nobu (Nobuyoshi Nakada)

- Target version set to 2.0.0

Thank you Hiroshi,

I'm reassigning this ticket to Nobu looking for approval.

CC: Usa, do you agree with Hiroshi conclusion and solution? If so, | will commit.
Thank you.

#2 - 07/24/2012 09:52 AM - luislavena (Luis Lavena)

- Assignee changed from nobu (Nobuyoshi Nakada) to h.shirosaki (Hiroshi Shirosaki)

=begin
Thank you Usa,

Hiroshi, see comments from Usa at [ruby-core:46694]:

About Hiroshi's patch, | don't think the name "fake_pow" is
a good name.

We should use "rb_w32_" prefix for the published name.

| think the patch is OK except it.

Please commit variant following those suggestions (e.g. rb_w32_pow)
=end

#3 - 07/24/2012 09:53 AM - usa (Usaku NAKAMURA)
Hello,

In message "[ruby-core:46690] [ruby-trunk - Bug #6784][Assigned] Test failures related to numeric with x64 mingw"
on Jul.24,2012 08:13:27, luislavena@gmail.com wrote:

06/17/2025

2/3


bugs.ruby-lang.org/issues/6784
bugs.ruby-lang.org/issues/6784
https://redmine.ruby-lang.org/issues/6784
mailto:luislavena@gmail.com

CC: Usa, do you agree with Hiroshi conclusion and solution? If so, | will commit.

| have not set up the 64bit mingw environment yet.
Therefore, | have not checked this.

However, probably, it will be the problem of mingw, since it
has not occurred in mswin.

About Hiroshi's patch, | don't think the name "fake_pow" is
a good name.

We should use "rb_w32_" prefix for the published name.

| think the patch is OK except it.

Regards,
U.Nakamura usa@garbagecollect.jp

#4 - 07/25/2012 12:12 AM - Anonymous
- Status changed from Assigned to Closed

- % Done changed from 0 to 100

This issue was solved with changeset r36522.
Hiroshi, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.
May Ruby be with you.

Fix broken pow() on x64-mingw32

e include/ruby/win32.h (rb_w32_pow): add new function.
We use powl() instead of broken pow() for x64-mingw32. This workaround
fixes test failures related to floating point numeric.
[ruby-core:46686] [Bug #6784]

Files

0001-Fix-broken-pow-of-mingw.patch 1.03 KB
